#!/bin/bash
#
# nrComm Lib install script
# Copyrigt(C) 2001 Roman Novgoroodov
# http://deepsoftware.ru
# email:noro@chat.ru
#
#
MSGERROR='ERROR:'
MSGINSTPATH='Please enter nrComm Lib install path'

KYLIX1CONF='/usr/local/etc/delphi60rc.conf'
KYLIX1CONF2='/root/.borland/delphi60rc'
KYLIX2CONF='/usr/local/etc/delphi65rc.conf'
KYLIX2CONF2='/root/.borland/delphi65rc'
NRKYLIX1SRC='/kylix1'
NRKYLIX2SRC='/kylix2'

NRCOMMTAR='nrcommlib.tar'

function CheckKylix {  
  if [ -e $KYLIXCONF ]; then
    kxroot=`cat $KYLIXCONF |grep "DelphiRoot="`
    kxroot=`echo $kxroot |awk -F. '{printf substr($1,12)}'`
    Chk=0    
  else
    Chk=1
  fi
  return $Chk
}

function BuildPackage {
  cd .$NRKYLIXSRC
  $kxroot/bin/dcc  -u$kxroot/lib -o$kxroot/bin nrcommlib.dpk
  cd ..
  libpath=`cat $KYLIXCONF2 |grep "Search Path="`
  libpath=`echo $libpath |awk -F. '{printf substr($1,13)}'`
  libpath=`echo $libpath |awk -F. '{printf substr($1,1,index($1,"Package")-2)}'`
  nnn=':'$nrroot$NRKYLIXSRC
  libpath=`echo $libpath |awk -F. '{printf gensub("'$nnn'","","g",$1)}'`
  libpath=$libpath':'$nrroot$NRKYLIXSRC

  ./demo/iniset "$KYLIXCONF2" "Library" "Search Path" "$libpath"
  nrso=$libpath'/'
  ./demo/iniset "$KYLIXCONF2" "Known Packages" "$nrroot$NRKYLIXSRC/bplnrcommlib.so" "nrComm Lib"
  return 1;
}

clear
echo "nrComm Lib v5.03 (C) Roman Novgorodov DeepSoftware.Ru"
echo 
echo "Welcome to nrComm Lib setup script."
echo 
echo "Please shutdown all runned Kylix programs before continue"
echo -n "when ready press <Enter>"
read

# -------------------------
# Checking Install File ...

if [ -e $NRCOMMTAR ]; then
  echo  
else
  echo $MSGERROR "nrComm Lib tar image not found !!! " 
  exit 0
fi

# --------------------------------
# Request the destination path ...

echo $MSGINSTPATH
echo -n '[default path is '$HOME'/nrcommlib]:'
read nrroot
if [ "$nrroot" = "" ]; then 
  nrroot=$HOME'/nrcommlib' 
fi

echo
echo 'nrComm Lib Home Path will be ='$nrroot
echo
if [ -e $nrroot ]; then
  echo "Copying file ..." 
else
  mkdir $nrroot
fi

# --------------------------------
# Extract TAR file ...

cp -f $NRCOMMTAR $nrroot
cd $nrroot
tar xf $NRCOMMTAR
rm $NRCOMMTAR

# --------------------------------
# Checking Kylix1 

echo
KYLIXCONF=$KYLIX1CONF
KYLIXCONF2=$KYLIX1CONF2
if ! CheckKylix; then
  echo "Kylix 1 not found."
else
  # --------------------------------
  # Build Package for Kylix1 
  echo "Kylix 1 Home Path="$kxroot 
  echo "Build package Kylix 1 ..."
  NRKYLIXSRC=$NRKYLIX1SRC
  BuildPackage
  echo
fi

# --------------------------------
# Checking Kylix2
echo
KYLIXCONF=$KYLIX2CONF
KYLIXCONF2=$KYLIX2CONF2
if ! CheckKylix; then
  echo "Kylix 2 not found."
else
  # --------------------------------
  # Build Package for Kylix2
  echo "Kylix 2 Home Path="$kxroot 
  echo "Build package Kylix 2 ..."
  NRKYLIXSRC=$NRKYLIX2SRC
  BuildPackage
  echo
fi

rm ./demo/iniset
echo
echo "Installation finished!"
echo
echo "don't forget read readme.txt and license.txt"
echo
echo "Contacts:"
echo "Web:   http://deepsoftware.ru/"
echo "email: noro@chat.ru"
echo ""
echo -n "press <Enter>"

read
